#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>
#include <stdio.h>
#include <time.h>
#include <ctype.h>
#include <errno.h>
#include<smf.h>

void exportmidi(int *pitcharray, int numevents, int *velarray, float *rhyarray)
{

    const char *file_name = "TestMID.mid";
    int i, j;
    int number_of_tracks = 1;
    int my_events; //number of events you want to put into this track
    my_events = numevents;
    int ret;
    int *pitchnums;
    int *velnums;
    float *rhyvals;

    smf_t *smf;
    smf_track_t *track;
    smf_event_t *event;
    smf_tempo_t *tempo;

    smf = smf_new();
    if (smf == NULL)
    {
        printf("Whoops");
        return;
    }
    smf_set_ppqn(smf, 960); //Division ppqn. Musit come after smf_new()
    smf_set_format(smf, 0); //type 0

    pitchnums=(int*)calloc(my_events+1,sizeof(int));/*pointer 'pitchnums' is allocated
				  integers and treated like an array */
    velnums=(int*)calloc(my_events+1,sizeof(int));/*pointer 'velnums' is allocated
				  integers and treated like an array */
    rhyvals=(float*)calloc(my_events+1,sizeof(float));/*pointer 'rhyvals' is allocated
				  floats and treated like an array */

    pitchnums = pitcharray;
    velnums = velarray;
    rhyvals = rhyarray;

    //+++++ OUTER LOOP ++++++//
    for (i = 1; i <= number_of_tracks; i++)
    {
        track = smf_track_new();
        if (track == NULL)
        {
            printf("Whoops_track null");
            return;
        }
        smf_add_track(smf, track);

        //+++++ ADD META EVENTS ++++++//
        /*time sig: FF 58 04 nn dd cc bb */
        event = smf_midi_timesig(4,4); //4/4
        smf_track_add_event_delta_pulses(track, event, 0);

        /* key signature: FF 59 02 sf mi */
        event = smf_midi_keysig(0,0); //key of C
        smf_track_add_event_delta_pulses(track, event, 0);

        /* tempo: FF 51 03 tt tt tt */
        event = smf_midi_tempo (60); //enter BPM, not microseconds.
        smf_track_add_event_delta_pulses(track, event, 0);


        //+++++ INNER LOOP ++++++//
        for (j = 1; j <= my_events; j++)  //note number of my_events set above
        {
            //note ON
            //event = smf_event_new_from_bytes(0x90, pitchnums[j], 0x7f);
            event = smf_event_new_from_bytes(0x90, pitchnums[j], velnums[j]);
            if (event == NULL )
            {
                printf("Whoops_event null");
                return;
            }
            smf_track_add_event_delta_pulses(track, event, 0.0);

            //note OFF
            event = smf_event_new_from_bytes(0x80, pitchnums[j], 0x0);
            if (event == NULL )
            {
                printf("Whoops_event null");
                return;
            }
            smf_track_add_event_delta_pulses(track, event, 960 * rhyvals[j]);

        } //ends inner events loop
    }//ends outer tracks loop

    //+++++SAVES TO FILE+++++//
    ret = smf_save(smf, file_name);  //this saves the .mid file
    if (ret)
    {
        printf("Whoops_ret");
        return;
    }

    //+++++ CLEAN UP MEMORY +++++//
    smf_delete(smf);


    free(pitchnums); //free memory
    free(velnums);
    free(rhyvals);

    return 0;
}
